<?php
/*
 * This file is part of the easy-CMS project.
 * easy-CMS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * easy-CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with easy-CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

include_once('classes/core/CoreObject.class.php');

/**
 * Node DiskUsage
 *
 * @author  cedseven
 * @package System
 */
class DiskUsage extends CoreObject {

	/**
	 * Node filesCount
	 *
	 * @access protected
	 * @var    integer
	 */
	var $filesCount;

	/**
	 * Node directoriesCount
	 *
	 * @access protected
	 * @var    integer
	 */
	var $directoriesCount;

	/**
	 * Node diskUsage
	 *
	 * @access protected
	 * @var    integer
	 */
	var $diskUsage;

	/**
	 * Constructor
	 *
	 * @param string $dir
	 */
	function DiskUsage($dir='') {
		$this->setDirectory($dir);
	}

	function reset() {
		$diskUsage				= 0;
		$filesCount				= 0;
		$directoriesCount = 0;
	}

	function setDirectory($dir) {
		$this->reset();
		if($dir != '') {
			$this->diskUsage = $this->directoryUsage($dir);
		}
	}

	function getFilesCount() {
		return $this->filesCount;
	}

	function getDirectoriesCount() {
		return $this->directoriesCount;
	}

	function getUsage($base = 1) {
		$usage = sprintf("%.2f", ($this->diskUsage/$base));
		return $usage;
	}

	function directoryUsage($dir) {
		$size = 0;
		if(is_dir($dir)) {
			if ($dh = opendir($dir)) {
				while (($item = readdir($dh)) !== false) {
					if ($item != '.' && $item != '..') {
						$file = $dir."/".$item;
						if (is_file($file)) {
							$size += filesize($file);
							$this->filesCount++;
						}
						else if (is_dir($file)) {
							$size += $this->directoryUsage($file);
							$this->directoriesCount++;
						}
					}
				}
			}
		}
		return $size;
	}
}

?>